// MockSocket.h
#include "SocketInterface.h"
#include <gmock/gmock.h>

class MockSocket : public SocketInterface {
public:
    MOCK_METHOD(void, connect, (const std::string& host, unsigned short port), (override));
    MOCK_METHOD(void, writeLine, (const std::string& data), (override));
    MOCK_METHOD(std::string, readLine, (), (override));
    MOCK_METHOD(bool, canRead, (double timeout), (override));
    MOCK_METHOD(bool, isClosed, (), (override));
    MOCK_METHOD(void, close, (), (override));
    MOCK_METHOD(void, prepareSSL, (bool incoming), (override));
    MOCK_METHOD(void, startSSL, (bool incoming), (override));
};
